program define general

*** initial settings, determination of the variables to be checked
	
	set more off
	clear
	capture log close
	cd  "FOLDER NAME"
	local i=1
	while "`1'"~="" {
		local arg`i'="`1'"
		local i=`i'+1
		mac shift
	}
	local checknum=`i'-2
	local country="`arg1'"
	forvalues j=1(1)`checknum' {
		local k=`j'+1
		local checkvar`j'="`arg`k''"
	}
	
	
*** checking q0100 (or some other variable being the PSU variable)
	
	use sample_data_`country', clear
	gen goodcase=0
	save, replace
	
	use sample_key_`country', clear
	preserve
	local rownum=_N
	forvalues i=1(1)`rownum' {	
		local a=`checkvar1' in `i'
		use sample_data_`country', clear
		local rownumber=_N
		forvalues j=1(1)`rownumber' {
			if `checkvar1'==`a' in `j' {
				quietly replace goodcase=1 in `j'
			}
		}
		quietly save, replace
		restore, preserve
	}
	use sample_data_`country', clear
	drop if goodcase==1
	keep id `checkvar1'
	save sample_PSUreport_`country', replace
	use sample_data_`country', clear
	drop goodcase
	save, replace
	
*** checking the additional variables using the PSU variable as reference

	restore, preserve
	if `checknum'>1 {
		tempname tab1
		if `checknum'==2 {
			postfile `tab1' long id `checkvar1' `checkvar2'  `checkvar1'_cor `checkvar2'_cor   using sample_report_`country', replace
		}
		if `checknum'==3 {
			postfile `tab1' long id `checkvar1' `checkvar2' `checkvar3' `checkvar1'_cor `checkvar2'_cor `checkvar3'_cor   using sample_report_`country', replace
		}
		if `checknum'==4 {
			postfile `tab1' long id `checkvar1' `checkvar2' `checkvar3' `checkvar4' `checkvar1'_cor `checkvar2'_cor `checkvar3'_cor  `checkvar4'_cor using sample_report_`country', replace
		}
		local rownum=_N
		forvalues i=1(1)`rownum' {
			forvalues l=1(1)`checknum' {
				local a`l'=`checkvar`l'' in `i'	
			}
			use sample_data_`country', clear
				
			quietly keep if `checkvar1'==`a1'
			local rownumber=_N
			forvalues j=1(1)`rownumber' {
				local ide=id in `j'
				forvalues l=1(1)`checknum' {
					local er`l'=`a`l'' 	
				}
				local ermes=0
				forvalues l=2(1)`checknum' {
				 	if `checkvar`l''~=`a`l'' in `j' {	 		
				 		local er`l'=`checkvar`l'' in `j'
				 		local ermes=1
				 		quietly replace `checkvar`l''=`a`l'' in `j'
				 	}
			 	}
			 	
			 	
			 	if `ermes'==1 {
			 		if `checknum'==2 {
			 			quietly post `tab1' (`ide') (`er1') (`er2') (`a1') (`a2') 
					}
			 		if `checknum'==3 {
			 			quietly post `tab1' (`ide') (`er1') (`er2') (`er3') (`a1') (`a2') (`a3')
					}
					if `checknum'==4 {
			 			quietly post `tab1' (`ide') (`er1') (`er2') (`er3') (`er4') (`a1') (`a2') (`a3') (`a4')
					}
					quietly save sample_data_corrected, replace
				}
			 }
			 
			 restore, preserve
		}
		
		postclose `tab1'
	}	


		
end 
exit
		

